#include<stdio.h>
#include<stdlib.h>

__global__ void add(int *a, int *b, int *c)
{
	c[ threadIdx.x] = a[ threadIdx.x] + b[ threadIdx.x];
}


int main(int argc, char ** argv)
{
	int N = atoi(argv[1]); //  Will be number of threads for add<<<1,N>>>, with N < 513
	int i;
	int *a, *b, *c;
	int *d_a, *d_b, *d_c;

	int size = N*sizeof(int);

	printf("\nN = %d, and the number of bytes in each array will be %d", N, size);

	a = (int *)malloc(size);
	b = (int *)malloc(size);
	c = (int *)malloc(size);

	for (i = 0; i < N; i++) 
	{
		a[i] = i;
		b[i] = i*i;
	}

	for (i = 0; i < N; i++) 
	{
		printf("A[%d] = %d, B[%d] = %d\n", i, a[i], i, b[i]);
	}

//	random_ints(a, N);
//	random_ints(b, N);

	cudaMalloc((void **)&d_a, size);
	cudaMalloc((void **)&d_b, size);
	cudaMalloc((void **)&d_c, size);

	cudaMemcpy(d_a, a, size, cudaMemcpyHostToDevice);
	cudaMemcpy(d_b, b, size, cudaMemcpyHostToDevice);

	add<<<1,N>>>(d_a, d_b, d_c);

	cudaMemcpy(c, d_c, size, cudaMemcpyDeviceToHost);
	
	printf("\n");

	for (i = 0; i < N; i++) 
	{
		printf("A[%d] = %d, B[%d] = %d, C[%d] = %d\n", i, a[i], i, b[i], i, c[i]);
	}
	
	cudaFree(d_a);
	cudaFree(d_b);
	cudaFree(d_c);

	free(a);
	free(b);
	free(c);

	return 0;
}
