#include<stdio.h>
#include<stdlib.h>

__global__ void add(int *a, int *b, int *c, int *A, int *B, int *C, int n)
{
	int index = threadIdx.x + blockIdx.x*blockDim.x;

	a[ index] = threadIdx.x;
	b[ index] = blockDim.x;
	c[ index] = blockIdx.x;

	if (index < n)
	{
		C[ index] = A[index] + B[index];
	}
}


int main(int argc, char ** argv)
{

	int L = atoi(argv[1]); //  Length of vectors
//	int M = atoi(argv[2]); //  Will be number of blocks for add<<<M,1>>>
	int N = atoi(argv[2]); //  Will be number of threads for add<<<1,N>>>, with N < 513

	int M = (L+(N-1))/N;

	int i;
	int *a, *b, *c, *A, *B, *C;
	int *d_a, *d_b, *d_c, *d_A, *d_B, *d_C;

	int size = L*sizeof(int);

	printf("\nN = %d, and the number of bytes in each array will be %d.\n", L, size);


	A = (int *)malloc(size);
	B = (int *)malloc(size);
	C = (int *)malloc(size);

	a = (int *)malloc(size);
	b = (int *)malloc(size);
	c = (int *)malloc(size);


	for (i = 0; i < L; i++) 
	{
		a[i] = 0;
		b[i] = 0;
		c[i] = 0;
		A[i] = i;
		B[i] = i*(i-1);
	}

//	for (i = 0; i < N; i++) 
//	{
//		printf("A[%d] = %d, B[%d] = %d\n", i, A[i], i, B[i]);
//	}

//	random_ints(a, N);
//	random_ints(b, N);

	cudaMalloc((void **)&d_A, size);
	cudaMalloc((void **)&d_B, size);
	cudaMalloc((void **)&d_C, size);

	cudaMalloc((void **)&d_a, size);
	cudaMalloc((void **)&d_b, size);
	cudaMalloc((void **)&d_c, size);


	cudaMemcpy(d_A, A, size, cudaMemcpyHostToDevice);
	cudaMemcpy(d_B, B, size, cudaMemcpyHostToDevice);
	cudaMemcpy(d_C, C, size, cudaMemcpyHostToDevice);

	cudaMemcpy(d_a, a, size, cudaMemcpyHostToDevice);
	cudaMemcpy(d_b, b, size, cudaMemcpyHostToDevice);

	add<<<M, N>>>(d_a, d_b, d_c, d_A, d_B, d_C, L);

	cudaMemcpy(A, d_A, size, cudaMemcpyDeviceToHost);
	cudaMemcpy(B, d_B, size, cudaMemcpyDeviceToHost);
	cudaMemcpy(C, d_C, size, cudaMemcpyDeviceToHost);

	cudaMemcpy(a, d_a, size, cudaMemcpyDeviceToHost);
	cudaMemcpy(b, d_b, size, cudaMemcpyDeviceToHost);
	cudaMemcpy(c, d_c, size, cudaMemcpyDeviceToHost);
	
	printf("\n");

	for (i = 0; i < L; i++) 
	{
		printf("A[%d] = %d, B[%d] = %d, C[%d] = %d, threadIdx.x  = %d, blockDim.x = %d and blockIdx.x = %d\n", i, A[i], i, B[i], i, C[i], a[i], b[i], c[i]);
	}
	
	cudaFree(d_A);
	cudaFree(d_B);
	cudaFree(d_C);

	cudaFree(d_a);
	cudaFree(d_b);
	cudaFree(d_c);

	free(A);
	free(B);
	free(C);

	free(a);
	free(b);
	free(c);

	return 0;
}
